## exD-2.py
# AE3M33UI - Artificial Intellignece course, FEE CTU in Prague
#
# Exercise D-2: Basis expansion for linear classification. SVM.

from sklearn import linear_model, pipeline, svm

from mpg import *
from plotting import *
from model_evaluation import *
from mapping import *

## Load 2D data for classification
X,y = load_mpg_for_2D_classification(['disp','hp'])
plot_xy_classified_data(X[:,0], X[:,1], y, xlbl='disp', ylbl='hp')

print('\n=== Comparison of several classification models ===\n')

## Logistic regression model with original features only
raise NotImplementedError
# <YOUR CODE HERE>
# logr = ...
plot_2D_class_model(logr)

## The error of the model
err = compute_model_error(logr, X, y, compute_err_01)
# Build the message and display it
msg = 'Pure logistic regression: error = {:.3f}'.format(err)
title(msg)
print(msg)

## Logistic regression with purely polynomial terms
figure()
plot_xy_classified_data(X[:,0], X[:,1], y, xlbl='disp', ylbl='hp')
degree = 2

raise NotImplementedError
# <YOUR CODE HERE>

# Build the message and display it
msg = 'Logistic regression with pure polynomials (deg = {:d}): error = {:.3f}'.format(degree, err)
title(msg)
print(msg)

## Logistic regression with fully polynomial mapping
figure()
plot_xy_classified_data(X[:,0], X[:,1], y, xlbl='disp', ylbl='hp')
degree = 2

raise NotImplementedError
# <YOUR CODE HERE>

# Build the message and display it
msg = 'Logistic regression with full polynomial mapping (deg = {:d}): error = {:.3f}'.format(degree, err)
title(msg)
print(msg)


## Support vector classification with linear kernel
figure()
plot_xy_classified_data(X[:,0], X[:,1], y, xlbl='disp', ylbl='hp')

raise NotImplementedError
# <YOUR CODE HERE>

# Build the message and display it
msg = 'SVM with linear kernel: error = {:.3f}'.format(err)
title(msg)
print(msg)

## Support vector classification with RBF kernel
figure()
plot_xy_classified_data(X[:,0], X[:,1], y, xlbl='disp', ylbl='hp')

raise NotImplementedError
# <YOUR CODE HERE>

# Build the message and display it
msg = 'SVM with RBF kernel: error = {:.3f}'.format(err)
title(msg)
print(msg)





